<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $template, $conf;

include_once(STUFFS_PATH . 'include/functions.inc.php');
include_once(STUFFS_PATH . 'admin/functions.inc.php');
load_language('plugin.lang', STUFFS_PATH);

if (!isset($_GET['type']) or !is_dir(STUFFS_PATH . 'modules/' . $_GET['type']))
{
  die('Wrong parameters...');
}
else
{
  $type = $_GET['type'];
}

// Cas particulier des News
if ($type == 'News') include(STUFFS_PATH . 'modules/News/config.inc.php');

// Enregistrement du module
if (isset($_POST['submit']) and !is_adviser())
{
  include(STUFFS_PATH . 'modules/' . $type . '/config.inc.php');
  if (empty($page['errors']))
  {
    if (empty($_POST['module_name']))
    {
      array_push($page['errors'], l10n('stuffs_no_name'));
    }
    else
    {
      $module_name = $_POST['module_name'];
      $desc = (!empty($_POST['module_desc']) ? '"' . $_POST['module_desc'] . '"' : 'NULL');
      $groups = (!empty($_POST['groups']) ? '"' . implode(',', $_POST['groups']) . '"' : 'NULL');
      $users = (!empty($_POST['users']) ? '"' . implode(',', $_POST['users']) . '"' : 'NULL');
      $show_title = isset($_POST['show_title']) ? '"true"' : '"false"';
      $on_home = isset($_POST['on_home'])  ? '"true"' : '"false"';
      $on_cats = isset($_POST['on_cats'])  ? '"true"' : '"false"';
      $on_picture = isset($_POST['on_picture'])  ? '"true"' : '"false"';

			$sav_datas = (!empty($datas) ? '"' . addslashes(serialize($datas)) . '"' : 'NULL');

      if (isset($_GET['edit']))
      {			
        pwg_query('
UPDATE ' . STUFFS_TABLE . '
SET name ="' . $module_name . '",
		descr=' . $desc . ',
		type="' . $type . '",
		datas=' . $sav_datas . ',
		users=' . $users . ',
		groups=' . $groups . ',
    show_title=' . $show_title .',
    on_home=' . $on_home .',
    on_cats=' . $on_cats . ',
    on_picture='. $on_picture . '
WHERE id = ' . $_GET['edit'] . ';');
      }
      else
      {
        $query = 'SELECT IF(MAX(id)+1 IS NULL, 1, MAX(id)+1) AS next_element_id  FROM ' . STUFFS_TABLE . ' ;';
        list($next_element_id) = mysql_fetch_array(pwg_query($query));

        $query = 'SELECT MAX(pos)+1 AS next_pos  FROM ' . STUFFS_TABLE . ' ;';
        list($pos) = mysql_fetch_array(pwg_query($query));

        $query = '
INSERT INTO ' . STUFFS_TABLE . ' ( id, pos, name, descr, type, datas, users, groups, show_title, on_home, on_cats, on_picture, id_line, width )
VALUES (' . $next_element_id . ' ,
	' . $pos . ',
	"' . $module_name . '",
	' . $desc . ',
	"' . $type . '",
	' . $sav_datas . ',
	' . $users . ',
	' . $groups . ',
  ' . $show_title . ',
  ' . $on_home . ',
  ' . $on_cats . ',
  ' . $on_picture . ',
  NULL,
  NULL);';
        pwg_query($query);
      }

      redirect(PHPWG_ROOT_PATH.'admin.php?page=plugin&section=' . STUFFS_DIR . '%2Fadmin%2Fadmin.php');
    }
  }
}

// Rcupration des donnes du module
if (isset($_GET['edit']))
{
  $q = ('SELECT * FROM ' . STUFFS_TABLE . ' WHERE id = ' . $_GET['edit'] . ';');
  $module = mysql_fetch_array(pwg_query($q));

  $module['users'] = explode(',', $module['users']);
  $module['groups'] = explode(',', $module['groups']);

  $datas = (!empty($module['datas']) ? unserialize($module['datas']) : false);

  $template->assign(array(
    'STUFFS_TITLE' => l10n('stuffs_edit_mod') . ' <i>' . trigger_event('render_stuffs_name', $module['name']) . '</i>',
    'MODULE_NAME' => $module['name'],
    'DESC_VALUE' => (isset($module['descr']) ? $module['descr'] : ''),
    'show_title_CHECKED' => ($module['show_title'] == 'true' ? 'checked="checked"' : ''),
    'on_home_CHECKED' => ($module['on_home'] == 'true' ? 'checked="checked"' : ''),
    'on_cats_CHECKED' => ($module['on_cats'] == 'true' ? 'checked="checked"' : ''),
    'on_picture_CHECKED' => ($module['on_picture'] == 'true' ? 'checked="checked"' : '')));
}
else
{
  $module['users'] = array('guest', 'generic', 'normal', 'admin', 'webmaster');
  $module['groups'] = array();
  $template->assign(array(
    'STUFFS_TITLE' => l10n('stuffs_add_mod'),
    'MODULE_NAME' => l10n('module_name_' . $type),
    'show_title_CHECKED' => 'checked="checked"',
    'on_home_CHECKED' => 'checked="checked"'));
}

// Selection des utilisateurs
$template->assign('user_perm', array(
  'GUEST' => (in_array('guest', $module['users']) ? 'checked="checked"' : ''),
  'GENERIC' => (in_array('generic', $module['users']) ? 'checked="checked"' : ''),
  'NORMAL' => (in_array('normal', $module['users']) ? 'checked="checked"' : ''),
  'ADMIN' => (in_array('admin', $module['users']) ? 'checked="checked"' : ''),
  'WEBMASTER' => (in_array('webmaster', $module['users']) ? 'checked="checked"' : '')));

// Selection des groupes
$groups = get_all_groups();
if (!empty($groups))
{
  $template->assign('group_perm', array('GROUPSELECTION' => get_html_groups_selection($groups, 'groups', $module['groups'])));
}

// Configuration du module
include_once(STUFFS_PATH . 'modules/' . $type . '/config.inc.php');

$template->set_filenames(array('plugin_admin_content' => dirname(__FILE__) . '/template/add_module.tpl'));
$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');

?>